package com.fdkankan.platform.user.factory.impl;

import com.alibaba.fastjson.JSONObject;
import com.fdkankan.common.constant.Constant;
import com.fdkankan.common.constant.ErrorCode;
import com.fdkankan.common.exception.BusinessException;
import com.fdkankan.platform.order.entity.CommerceOrder;
import com.fdkankan.platform.order.request.RequestPlaceOrder;
import com.fdkankan.platform.order.service.ICommerceOrderService;
import com.fdkankan.platform.order.service.PayOrderService;
import com.fdkankan.platform.user.factory.Commerce;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.math.BigDecimal;

@Component
public class WechatCommerce implements Commerce {

    @Autowired
    private PayOrderService payOrderService;
    @Autowired
    private ICommerceOrderService commerceOrderService;

    @Override
    public JSONObject scanPay(RequestPlaceOrder order) throws Exception {
        CommerceOrder commerce = commerceOrderService.getById(order.getOrderId());
        if (commerce == null){
            throw new BusinessException(ErrorCode.FAILURE_CODE_8001);
        }
        String subject = Constant.COMMERCE_SUBJECT;
        BigDecimal totalFee = commerce.getAmount().multiply(new BigDecimal(100));
        String orderSn = commerce.getOrderSn();
        orderSn += "_commerce";
        return payOrderService.wechatScanPay(orderSn, subject, subject, totalFee);
    }

    @Override
    public JSONObject h5Pay(RequestPlaceOrder order, String ip) throws Exception {
        CommerceOrder commerce = commerceOrderService.getById(order.getOrderId());
        if (commerce == null){
            throw new BusinessException(ErrorCode.FAILURE_CODE_8001);
        }
        String subject = Constant.COMMERCE_SUBJECT;
        BigDecimal totalFee = commerce.getAmount().multiply(new BigDecimal(100));
        String orderSn = commerce.getOrderSn();
        orderSn += "_commerce";
        return payOrderService.wechatH5Pay(orderSn, subject, subject, totalFee, ip);
    }

    @Override
    public String getType() {
        return "wechat_3";
    }
}
